const yargs = require("yargs");
const {
  addNote,
  loadNote,
  readNote,
  deleteNote,
  displayNotes,
} = require("./utils/notes");

yargs.command({
  command: "add",
  description: "to add new note",
  builder: {
    title: {
      type: "string",
      demandOption: true,
      description: "title to add new note",
    },
    body: {
      type: "string",
      demandOption: true,
      description: "body to add new title",
    },
  },
  handler: (args) => {
    const { title, body } = args;
    addNote(title, body);
  },
});

yargs.command({
  command: "list",
  description: "show the full list",
  handler: () => {
    displayNotes();
  },
});

yargs.command({
  command: "read",
  description: "read a note",
  builder: {
    title: {
      type: "string",
      demandOption: true,
      description: "title to read a file",
    },
  },
  handler: (args) => {
    const { title } = args;
    console.log(readNote(title));
  },
});

yargs.command({
  command: "delete",
  description: "delete a note",
  builder: {
    title: {
      type: "string",
      demandOption: true,
      description: "title to delete a file",
    },
  },
  handler: (args) => {
    const { title } = args;
    console.log(deleteNote(title));
  },
});

yargs.parse();
