const fs = require("fs");
require("colors");

const loadNote = () => {
  try {
    const notesBuffer = fs.readFileSync("./notes.json");
    const notesString = notesBuffer.toString();
    return JSON.parse(notesString);
  } catch (err) {
    return [];
  }
};

const saveNote = (notes) => {
  fs.writeFileSync("./notes.json", JSON.stringify(notes));
  console.log("Saved".green);
};

const displayNotes = () => {
  const notes = loadNote();
  notes.forEach((value, index) => {
    console.log(`
    Note : ${index + 1}\n
    Title: ${value.title}\n
    Body: ${value.body}\n`);
  });
};

const addNote = (title, body) => {
  const notes = loadNote();
  const newNote = { title, body };
  const position = notes.findIndex((n) => n.title === title);
  if (position >= 0) {
    console.log("Try again! Already exist.");
    return;
  }
  notes.push(newNote);
  saveNote(notes);
};

const readNote = (title) => {
  const notes = loadNote();
  const note = notes.find((value) => value.title === title);
  if (note) {
    return note;
  } else {
    return "Note not Found";
  }
};

const deleteNote = (title) => {
  const notes = loadNote();
  const deleteNotePosition = notes.findIndex((value) => value.title === title);
  if (deleteNotePosition >= 0) {
    const filtered_notes = notes.filter(
      (value, index) => index != deleteNotePosition
    );
    saveNote(filtered_notes);
    return "Successfully Deleted";
  } else {
    return "Note not found";
  }
};

module.exports = {
  addNote,
  loadNote,
  displayNotes,
  readNote,
  deleteNote,
};
